cascading.pipe

## Class Operator

- java.lang.Object
- - cascading.pipe.Pipe
  - - cascading.pipe.Operator

All Implemented Interfaces:
  FlowElement, ScopedElement, Traceable, java.io.Serializable

Direct Known Subclasses:
  Each, Every

    public abstract class Operator
    extends Pipe

An Operator is a type of `Pipe`. Operators pass specified arguments to a given `BaseOperation`. The argFields value select the input fields used by the operation. By default the whole input Tuple is passes as arguments. The outFields value select the fields in the result Tuple returned by this Pipe. By default, the operation results of the given operation replace the input Tuple.

See Also:
  Serialized Form

### Field Summary

Fields
`protected Fields` `argumentSelector` Field argumentSelector
`protected Operation` `operation` Field operation
`protected Fields` `outputSelector` Field outputSelector
`protected PlannerLevel` `plannerLevel` Field assertionLevel

### Fields inherited from class cascading.pipe.Pipe

`configDef, name, nodeConfigDef, parent, previous, stepConfigDef`

### Constructor Summary

Constructors
`protected` `Operator(Operation operation)`
`protected` `Operator(Pipe previous, Fields argumentSelector, Operation operation)`
`protected` `Operator(Pipe previous, Fields argumentSelector, Operation operation, Fields outputSelector)`
`protected` `Operator(Pipe previous, Fields argumentSelector, PlannerLevel plannerLevel, PlannedOperation operation, Fields outputSelector)`
`protected` `Operator(Pipe previous, Operation operation)`
`protected` `Operator(Pipe previous, Operation operation, Fields outputSelector)`
`protected` `Operator(Pipe previous, PlannerLevel plannerLevel, PlannedOperation operation, Fields outputSelector)`
`protected` `Operator(java.lang.String name, Fields argumentSelector, Operation operation)`
`protected` `Operator(java.lang.String name, Fields argumentSelector, Operation operation, Fields outputSelector)`
`protected` `Operator(java.lang.String name, Fields argumentSelector, PlannerLevel plannerLevel, PlannedOperation operation, Fields outputSelector)`
`protected` `Operator(java.lang.String name, Operation operation)`
`protected` `Operator(java.lang.String name, Operation operation, Fields outputSelector)`
`protected` `Operator(java.lang.String name, PlannerLevel plannerLevel, PlannedOperation operation, Fields outputSelector)`

### Method Summary

Methods
`boolean` `equals(java.lang.Object object)`
`Fields` `getArgumentSelector()` Method getArgumentSelector returns the argumentSelector of this Operator object.
`Fields` `getFieldDeclaration()` Method getFieldDeclaration returns the fieldDeclaration of this Operator object.
`Operation` `getOperation()` Method getOperation returns the operation managed by this Operator object.
`Fields` `getOutputSelector()` Method getOutputSelector returns the outputSelector of this Operator object.
`PlannerLevel` `getPlannerLevel()` Method getPlannerLevel returns the plannerLevel of this Operator object.
`int` `hashCode()`
`boolean` `hasPlannerLevel()` Method hasPlannerLevel returns true if this Operator object holds a `PlannedOperation` object with an associated `PlannerLevel` level.
`abstract Scope` `outgoingScopeFor(java.util.Set<Scope> incomingScopes)` Method outgoingScopeFor returns the Scope this FlowElement hands off to the next FlowElement.
`protected void` `printInternal(java.lang.StringBuffer buffer, Scope scope)`
`protected Fields` `resolveRemainderFields(java.util.Set<Scope> incomingScopes, Fields argumentFields)`
`java.lang.String` `toString()`
`protected void` `verifyOperation()`

### Methods inherited from class cascading.pipe.Pipe

`getConfigDef, getHeads, getName, getNodeConfigDef, getParent, getPrevious, getStepConfigDef, getTrace, hasConfigDef, hasNodeConfigDef, hasStepConfigDef, id, named, names, pipes, print, resolveIncomingOperationArgumentFields, resolveIncomingOperationPassThroughFields, setParent`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### operation

    protected final Operation operation

Field operation

#### argumentSelector

    protected Fields argumentSelector

Field argumentSelector

#### outputSelector

    protected Fields outputSelector

Field outputSelector

#### plannerLevel

    protected PlannerLevel plannerLevel

Field assertionLevel

### Constructor Detail

#### Operator

    protected Operator(Operation operation)

#### Operator

    protected Operator(java.lang.String name,
            Operation operation)

#### Operator

    protected Operator(java.lang.String name,
            Operation operation,
            Fields outputSelector)

#### Operator

    protected Operator(java.lang.String name,
            Fields argumentSelector,
            Operation operation)

#### Operator

    protected Operator(java.lang.String name,
            Fields argumentSelector,
            Operation operation,
            Fields outputSelector)

#### Operator

    protected Operator(Pipe previous,
            Operation operation)

#### Operator

    protected Operator(Pipe previous,
            Fields argumentSelector,
            Operation operation)

#### Operator

    protected Operator(Pipe previous,
            Fields argumentSelector,
            Operation operation,
            Fields outputSelector)

#### Operator

    protected Operator(Pipe previous,
            Operation operation,
            Fields outputSelector)

#### Operator

    protected Operator(java.lang.String name,
            PlannerLevel plannerLevel,
            PlannedOperation operation,
            Fields outputSelector)

#### Operator

    protected Operator(java.lang.String name,
            Fields argumentSelector,
            PlannerLevel plannerLevel,
            PlannedOperation operation,
            Fields outputSelector)

#### Operator

    protected Operator(Pipe previous,
            PlannerLevel plannerLevel,
            PlannedOperation operation,
            Fields outputSelector)

#### Operator

    protected Operator(Pipe previous,
            Fields argumentSelector,
            PlannerLevel plannerLevel,
            PlannedOperation operation,
            Fields outputSelector)

### Method Detail

#### verifyOperation

    protected void verifyOperation()

#### getOperation

    public Operation getOperation()

Method getOperation returns the operation managed by this Operator object.

Returns:
  the operation (type Operation) of this Operator object.

#### getArgumentSelector

    public Fields getArgumentSelector()

Method getArgumentSelector returns the argumentSelector of this Operator object.

Returns:
  the argumentSelector (type Fields) of this Operator object.

#### getFieldDeclaration

    public Fields getFieldDeclaration()

Method getFieldDeclaration returns the fieldDeclaration of this Operator object.

Returns:
  the fieldDeclaration (type Fields) of this Operator object.

#### getOutputSelector

    public Fields getOutputSelector()

Method getOutputSelector returns the outputSelector of this Operator object.

Returns:
  the outputSelector (type Fields) of this Operator object.

#### getPlannerLevel

    public PlannerLevel getPlannerLevel()

Method getPlannerLevel returns the plannerLevel of this Operator object.

Returns:
  the plannerLevel (type PlannerLevel) of this Operator object.

#### hasPlannerLevel

    public boolean hasPlannerLevel()

Method hasPlannerLevel returns true if this Operator object holds a `PlannedOperation` object with an associated `PlannerLevel` level.

Returns:
  boolean

#### resolveRemainderFields

    protected Fields resolveRemainderFields(java.util.Set<Scope> incomingScopes,
                                Fields argumentFields)

#### outgoingScopeFor

    public abstract Scope outgoingScopeFor(java.util.Set<Scope> incomingScopes)

Description copied from interface: `ScopedElement`
Method outgoingScopeFor returns the Scope this FlowElement hands off to the next FlowElement.

Specified by:
  `outgoingScopeFor` in interface `ScopedElement`
Overrides:
  `outgoingScopeFor` in class `Pipe`
Parameters:
  `incomingScopes` - of type Set<Scope>
Returns:
  Scope

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `Pipe`

#### printInternal

    protected void printInternal(java.lang.StringBuffer buffer,
                     Scope scope)

Overrides:
  `printInternal` in class `Pipe`

#### equals

    public boolean equals(java.lang.Object object)

Overrides:
  `equals` in class `Pipe`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Pipe`